/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import javax.swing.*;
import javax.swing.border.LineBorder;
public class DialogueVariations extends JPanel
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -3126878741567792940L;
	double[][] PointV;
	int NbPointsV;
	boolean Dessine=false;
	JButton Valider,Correction;
	int Largeur,Hauteur,LargeurImage,LargDebut;
	int h[]=new int[5];
	int x[]=new int[10];
	int hImage[]=new int[10];
	Font En;FontMetrics fm;
	Font FX;FontMetrics FX1;
	final int TaillePolice=14;
	final double Cos=0.707107d;
	final double TF=10d; // Longueur flches
	
	public DialogueVariations(int x, int y, int Largeur , int Hauteur)
	{
		this.Largeur=Largeur;this.Hauteur=Hauteur;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		setLayout(null);
		Font En=new Font("", Font.BOLD, TaillePolice);fm = getFontMetrics(En);
		FX=new Font("Dialog", Font.BOLD, 16);FX1=getFontMetrics(FX);
		LargeurImage=fm.stringWidth("10.2");
		LargDebut=FX1.stringWidth(" f(x) ")+5;
		
		h[0]=5;h[4]=Hauteur-20;h[1]=h[0]+TaillePolice+30;
		h[2]=h[1]+TaillePolice+15;
		h[3]=h[4]-2*TaillePolice-25;
		
		
		Valider=new JButton("Valider votre courbe");Valider.setFont(En);Valider.setBounds(20,h[0],Largeur-40,20);
		Correction=new JButton("Correction");Correction.setFont(En);Correction.setBounds(20,h[4],Largeur-40,20);
		this.add(Valider);this.add(Correction);
	}
	public void Tableau(int NbPointsV, double[][] PointV)
	{
		this.PointV=PointV;
		this.NbPointsV=NbPointsV;
		for (int i=0;i<NbPointsV;i++)
		{
			x[i]=LargDebut+((Largeur-LargDebut-LargeurImage-5)*i)/(NbPointsV-1);
			if (i!=0) 
			{
				if (PointV[i-1][1]<PointV[i][1]) {hImage[i]=h[2];} else {hImage[i]=h[3];}
			}
			else
			{
				if (PointV[0][1]>PointV[1][1]) {hImage[0]=h[2];} else {hImage[0]=h[3];}
			}
		}
		
		Dessine=true;
		
	}
	public void paintComponent(Graphics Graph)
	{
		super.paintComponent(Graph);	
		if (Dessine)
		{
			Graph.setFont(FX);
			Graph.setColor(new Color(255,255,255));
			Graph.drawString(" x",5,h[1]);
			Graph.drawString("f(x)",5,(h[2]+h[3])/2);
			
			Graph.setFont(En);
			Graph.setColor(new Color(0,0,255));
			Graph.drawLine(5,(h[1]+h[2])/2,Largeur-5,(h[1]+h[2])/2);
			Graph.drawLine(x[0]-5,30,x[0]-5,Hauteur-30);
			Graph.setColor(new Color(0,255,0));
			
			
			for (int i=0;i<NbPointsV;i++)
			{
				Graph.drawString(""+PointV[i][0],x[i],h[1]);
				Graph.drawString(""+PointV[i][1],x[i],hImage[i]);
				if (i!=0)
				{
					int fin=x[i]-8;
					Graph.drawLine(x[i-1]+LargeurImage,hImage[i-1]+5,fin,hImage[i]);
					double lg=(double) (fin-(x[i-1]+LargeurImage));
					double ht=(double) (hImage[i]-(hImage[i-1]+5));
					double longueur=Math.sqrt(lg*lg+ht*ht);
					double xx=-TF*lg/longueur;
					double yy=-TF*ht/longueur;
					Graph.drawLine(fin,hImage[i],(int) ((xx-yy)*Cos+fin),(int) ((yy+xx)*Cos+hImage[i]));
					Graph.drawLine(fin,hImage[i],(int) ((xx+yy)*Cos+fin),(int) ((yy-xx)*Cos+hImage[i]));
				}
				
			}
			
		}
	}
}
