/*
 * Copyright Mr DROUOT Patrick since 2006
 * 
 * www.patrickdrouot2000@yahoo.fr
 * 
 * 
 * This file is part of GraphExotica.
 * GraphExotica is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2 of the License.
 * GraphExotica is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 

*/
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import javax.swing.*;
import javax.swing.border.LineBorder;
import java.awt.event.*;

public class DialogueVariations2 extends JPanel implements FocusListener
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 6970896824510664177L;
	Font En;FontMetrics fm;
	Font FX;FontMetrics FX1;
	final int TaillePolice=14;
	int Largeur,Hauteur,LargeurImage,LargDebut;
	int h[]=new int[5];
	int x[]=new int[10];
	int hImage[]=new int[10];
	JTextField Reponse[][]=new JTextField[10][3]; // 3: abscisses
	boolean Dessine=false;
	
	int NbPoints;
	double[][] Point;
	
	final double Cos=0.707107d;
	final double TF=10d;
	
	JButton Valider,Correction;
	
	public DialogueVariations2(int x, int y, int Largeur , int Hauteur)
	{
		this.Largeur=Largeur;this.Hauteur=Hauteur;
		setBorder(new LineBorder(new Color(255, 0, 0)));
		setBackground(new Color(0, 0, 0));
		setBounds(x,y,Largeur,Hauteur);	
		setLayout(null);
		Font En=new Font("", Font.BOLD, TaillePolice);fm = getFontMetrics(En);
		FX=new Font("Dialog", Font.BOLD, 16);FX1=getFontMetrics(FX);

		LargeurImage=fm.stringWidth("10.2");
		LargDebut=FX1.stringWidth(" f(x) ")+5;
		h[0]=5;h[4]=Hauteur-20;h[1]=h[0]+TaillePolice+30;
		h[2]=h[1]+TaillePolice+15;
		h[3]=h[4]-2*TaillePolice-25;

		Valider=new JButton("Valider votre courbe");Valider.setFont(En);Valider.setBounds(20,h[0],Largeur-40,20);
		Correction=new JButton("Correction");Correction.setFont(En);Correction.setBounds(20,h[4],Largeur-40,20);
	}
	public void Tableau(int NbPoints, double[][] Point)
	{
		int u;
		this.Point=Point;
		this.NbPoints=NbPoints;
		this.add(Valider);this.add(Correction);
		h[1]=h[1]-5;
		for (int i=0;i<NbPoints;i++)
		{
			x[i]=LargDebut+((Largeur-LargDebut-LargeurImage-5)*i)/(NbPoints-1);
			for (int j=0;j<3;j++)
			{	
				Reponse[i][j]=new JTextField("");
				if (j==2) {u=1;} else {u=j+2;}
				Reponse[i][j].setBounds(x[i],h[u],LargeurImage,15);
				Reponse[i][j].setHorizontalAlignment(SwingConstants.CENTER);
				Reponse[i][j].setFont(En);
				Reponse[i][j].setForeground(new Color(0,0,255));
				Reponse[i][j].addFocusListener(this);
				this.add(Reponse[i][j]);
			}
		}
		for (int i=0;i<NbPoints;i++)
		{
			Reponse[i][0].setNextFocusableComponent(Reponse[i][1]);
			Reponse[i][2].setNextFocusableComponent(Reponse[i][0]);
			if (i<(NbPoints-1)) Reponse[i][1].setNextFocusableComponent(Reponse[i+1][2]);
		}
		Reponse[NbPoints-1][1].setNextFocusableComponent(Reponse[0][2]);
		h[1]=h[1]+5;
		Reponse[0][2].requestFocus();
		Dessine=true;
	}
	public void paintComponent(Graphics Graph)
	{
		super.paintComponent(Graph);	
		if (Dessine)
		{
			Graph.setColor(new Color(255,255,255));
			Graph.setFont(FX);
			Graph.drawString(" x",5,h[1]);
			Graph.drawString("f(x)",5,(h[2]+h[3])/2);
			
			Graph.setColor(new Color(0,0,255));
			Graph.drawLine(5,(h[1]+h[2])/2,Largeur-5,(h[1]+h[2])/2);
			Graph.drawLine(x[0]-5,30,x[0]-5,Hauteur-30);
			Graph.setColor(new Color(0,255,0));
			
			Graph.setFont(En);
			for (int i=0;i<NbPoints;i++)
			{
				if (i!=0)
				{
					if (((Reponse[i][0].getText().length()!=0)|(Reponse[i][1].getText().length()!=0)) &&
					((Reponse[i-1][0].getText().length()!=0)|(Reponse[i-1][1].getText().length()!=0)))
					{
						int fin=x[i]-8;
						if (hImage[i]==hImage[i-1])
						{
							int h=hImage[i-1]+TaillePolice/2;
							Graph.drawLine(x[i-1]+LargeurImage,h,fin,h);
							Graph.drawLine(fin,h,fin-5,h-5);
							Graph.drawLine(fin,h,fin-5,h+5);
						}
						else
						{
							Graph.drawLine(x[i-1]+LargeurImage,hImage[i-1]+5,fin,hImage[i]);
							double lg=(double) (fin-(x[i-1]+LargeurImage));
							double ht=(double) (hImage[i]-(hImage[i-1]+5));
							double longueur=Math.sqrt(lg*lg+ht*ht);
							double xx=-TF*lg/longueur;
							double yy=-TF*ht/longueur;
							Graph.drawLine(fin,hImage[i],(int) ((xx-yy)*Cos+fin),(int) ((yy+xx)*Cos+hImage[i]));
							Graph.drawLine(fin,hImage[i],(int) ((xx+yy)*Cos+fin),(int) ((yy-xx)*Cos+hImage[i]));
						}	
					}
				}
				
			}
		}
	}
	public double Transmet(int i,int j)
	{	
		double t=1024d;
		try {t=new Double (Reponse[i][j].getText()).doubleValue();}
		catch (Exception ex) {}
		return(t);
	}
	public double TransmetForce(int i)
	{
		int j=0;
		if (Reponse[i][0].getText().length()==0) {j=1;}
		return (Transmet(i,j));
	}
	public double Arrondir(double nb) {return ((double)Math.round(nb*10))/10d;}
	public void Nettoie()
	{
		double t=0;
		for (int i=0;i<NbPoints;i++)
		{
			for (int j=0;j<3;j++)
			{
				try {t=new Double (Reponse[i][j].getText()).doubleValue();}
				catch (Exception ex) {Reponse[i][j].setText("");}
				if (Reponse[i][j].getText().length()!=0) {Reponse[i][j].setText(""+Arrondir(t));}
			}
		}	
	}
	public void CalculehImage()
	{
		for (int i=0;i<NbPoints;i++)
		{
			if (Reponse[i][0].getText().length()==0) {hImage[i]=h[3];} else {hImage[i]=h[2];}
		}
	}
	public void Focus(FocusEvent arg0)
	{
		int j=0;int i=0;
		for (int k=0;k<NbPoints;k++)
		{
			if (arg0.getSource()==Reponse[k][0]) {i=k;j=0;break;}
			if (arg0.getSource()==Reponse[k][1]) {i=k;j=1;break;}
		}
		
		Nettoie();
		if (Reponse[i][j].getText().length()!=0) {Reponse[i][1-j].setText("");}
		CalculehImage();
		repaint();
	}
	public void focusGained(FocusEvent arg0) 
	{}
	public void focusLost(FocusEvent arg0) 
	{
		Focus(arg0);
	}
}
